IOSS 2.0

Classes | Public Types | Public Member Functions | Static Public Attributes | Private Member Functions | Private Attributes | Friends | List of all members
Json::Value Class Reference

Represents a JSON value. More...

`#include <json.h>`

## Classes
struct | CommentInfo
class | CZString
union | ValueHolder

## Public Types
typedef std::vector< std::string > | Members
typedef ValueIterator | iterator
typedef ValueConstIterator | const_iterator
typedef Json::UInt | UInt
typedef Json::Int | Int
typedef Json::UInt64 | UInt64
typedef Json::Int64 | Int64
typedef Json::LargestInt | LargestInt
typedef Json::LargestUInt | LargestUInt
typedef Json::ArrayIndex | ArrayIndex
typedef std::map< CZString, Value > | ObjectValues

## Public Member Functions
| Value (ValueType type=nullValue)
| Create a default Value of the given type. More...
| Value (Int value)
| Value (UInt value)
| Value (Int64 value)
| Value (UInt64 value)
| Value (double value)
| Value (const char *value)
| Copy til first 0. (NULL causes to seg-fault.) More...
| Value (const char *beginValue, const char *endValue)
| Copy all, incl zeroes. More...
| Value (const StaticString &value)
| Constructs a value from a static string. More...
| Value (const std::string &value)
| Copy data() til size(). Embedded zeroes too. More...
| Value (bool value)
| Value (const Value &other)
| Deep copy. More...
| ~Value ()
Value & | operator= (Value other)
void | swap (Value &other)
| Swap everything. More...
void | swapPayload (Value &other)
| Swap values but leave comments and source offsets in place. More...
ValueType | type () const
bool | operator< (const Value &other) const
| Compare payload only, not comments etc. More...
bool | operator<= (const Value &other) const
bool | operator>= (const Value &other) const
bool | operator> (const Value &other) const
bool | operator== (const Value &other) const
bool | operator!= (const Value &other) const
int | compare (const Value &other) const
const char * | asCString () const
| Embedded zeroes could cause you trouble! More...
std::string | asString () const
| Embedded zeroes are possible. More...
bool | getString (char const **str, char const **end) const
Int | asInt () const
UInt | asUInt () const
Int64 | asInt64 () const
UInt64 | asUInt64 () const
LargestInt | asLargestInt () const
LargestUInt | asLargestUInt () const
float | asFloat () const
double | asDouble () const
bool | asBool () const
bool | isNull () const
bool | isBool () const
bool | isInt () const
bool | isInt64 () const
bool | isUInt () const
bool | isUInt64 () const
bool | isIntegral () const
bool | isDouble () const
bool | isNumeric () const
bool | isString () const
bool | isArray () const
bool | isObject () const
bool | isConvertibleTo (ValueType other) const
ArrayIndex | size () const
| Number of values in array or object. More...
bool | empty () const
| Return true if empty array, empty object, or null; otherwise, false. More...
bool | operator! () const
| Return isNull() More...
void | clear ()
void | resize (ArrayIndex size)
Value & | operator[] (ArrayIndex index)
Value & | operator[] (int index)
const Value & | operator[] (ArrayIndex index) const
const Value & | operator[] (int index) const
Value | get (ArrayIndex index, const Value &defaultValue) const
bool | isValidIndex (ArrayIndex index) const
| Return true if index < size(). More...
Value & | append (const Value &value)
| Append value to array at the end. More...
Value & | operator[] (const char *key)
const Value & | operator[] (const char *key) const
Value & | operator[] (const std::string &key)
const Value & | operator[] (const std::string &key) const
Value & | operator[] (const StaticString &key)
| Access an object value by name, create a null member if it does not exist. More...
Value | get (const char *key, const Value &defaultValue) const
Value | get (const char *key, const char *end, const Value &defaultValue) const
Value | get (const std::string &key, const Value &defaultValue) const
Value const * | find (char const *key, char const *end) const
Value const * | demand (char const *key, char const *end)
Value | removeMember (const char *key)
| Remove and return the named member. More...
Value | removeMember (const std::string &key)
bool | removeMember (const char *key, Value *removed)
bool | removeMember (std::string const &key, Value *removed)
| Remove the named map member. More...
bool | removeMember (const char *key, const char *end, Value *removed)
| Same as removeMember(std::string const& key, Value* removed) More...
bool | removeIndex (ArrayIndex i, Value *removed)
| Remove the indexed array element. More...
bool | isMember (const char *key) const
bool | isMember (const std::string &key) const
bool | isMember (const char *key, const char *end) const
| Same as isMember(std::string const& key)const. More...
Members | getMemberNames () const
| Return a list of the member names. More...
void | setComment (const char *comment, CommentPlacement placement)
void | setComment (const char *comment, size_t len, CommentPlacement placement)
| Comments must be //... or /* ... */. More...
void | setComment (const std::string &comment, CommentPlacement placement)
| Comments must be //... or /* ... */. More...
bool | hasComment (CommentPlacement placement) const
std::string | getComment (CommentPlacement placement) const
| Include delimiters and embedded newlines. More...
std::string | toStyledString () const
const_iterator | begin () const
const_iterator | end () const
iterator | begin ()
iterator | end ()
void | setOffsetStart (size_t start)
void | setOffsetLimit (size_t limit)
size_t | getOffsetStart () const
size_t | getOffsetLimit () const

## Static Public Attributes
static const Value & | null
static const Value & | nullRef
static const LargestInt | minLargestInt
| Minimum signed integer value that can be stored in a Json::Value. More...
static const LargestInt | maxLargestInt
| Maximum signed integer value that can be stored in a Json::Value. More...
static const LargestUInt | maxLargestUInt
| Maximum unsigned integer value that can be stored in a Json::Value. More...
static const Int | minInt
| Minimum signed int value that can be stored in a Json::Value. More...
static const Int | maxInt
| Maximum signed int value that can be stored in a Json::Value. More...
static const UInt | maxUInt
| Maximum unsigned int value that can be stored in a Json::Value. More...
static const Int64 | minInt64
| Minimum signed 64 bits int value that can be stored in a Json::Value. More...
static const Int64 | maxInt64
| Maximum signed 64 bits int value that can be stored in a Json::Value. More...
static const UInt64 | maxUInt64
| Maximum unsigned 64 bits int value that can be stored in a Json::Value. More...

## Private Member Functions
void | initBasic (ValueType type, bool allocated=false)
Value & | resolveReference (const char *key)
Value & | resolveReference (const char *key, const char *end)

## Private Attributes
union Json::Value::ValueHolder | value_
ValueType | type_: 8
unsigned int | allocated_: 1
CommentInfo * | comments_
size_t | start_
size_t | limit_

## Friends
class | ValueIteratorBase

## Detailed Description

Represents a JSON value.

This class is a discriminated union wrapper that can represents a:

- signed integer [range: Value::minInt - Value::maxInt]
- unsigned integer (range: 0 - Value::maxUInt)
- double
- UTF-8 string
- boolean
- 'null'
- an ordered list of Value
- collection of name/value pairs (javascript object)

The type of the held value is represented by a ValueType and can be obtained using type().

Values of an objectValue or arrayValue can be accessed using operator[]() methods. Non-const methods will automatically create the a nullValue element if it does not exist. The sequence of an arrayValue will be automatically resized and initialized with nullValue. resize() can be used to enlarge or truncate an arrayValue.

The get() methods can be used to obtain default value in the case the required element does not exist.

It is possible to iterate over the list of a objectValue values using the getMemberNames() method.

Note
  Value string-length fit in size_t, but keys must be < 2^30. (The reason is an implementation detail.) A #CharReader will raise an exception if a bound is exceeded to avoid security holes in your app, but the Value API does not check bounds. That is the responsibility of the caller.

## Member Typedef Documentation

## ◆ ArrayIndex

typedef Json::ArrayIndex Json::Value::ArrayIndex

## ◆ const_iterator

typedef ValueConstIterator Json::Value::const_iterator

## ◆ Int

typedef Json::Int Json::Value::Int

## ◆ Int64

typedef Json::Int64 Json::Value::Int64

## ◆ iterator

typedef ValueIterator Json::Value::iterator

## ◆ LargestInt

typedef Json::LargestInt Json::Value::LargestInt

## ◆ LargestUInt

typedef Json::LargestUInt Json::Value::LargestUInt

## ◆ Members

typedef std::vector<std::string> Json::Value::Members

## ◆ ObjectValues

typedef std::map<CZString, Value> Json::Value::ObjectValues

## ◆ UInt

typedef Json::UInt Json::Value::UInt

## ◆ UInt64

typedef Json::UInt64 Json::Value::UInt64

## Constructor & Destructor Documentation

## ◆ Value() [1/12]

Json::Value::Value | ( | ValueType | type = `nullValue` | ) |

Create a default Value of the given type.

This is a very useful constructor. To create an empty array, pass arrayValue. To create an empty object, pass objectValue. Another Value can then be set to this one by assignment. This is useful since clear() and resize() will not alter types.

    Examples:

Json::Value null_value; // null
Json::Value arr_value(Json::arrayValue); // []
Json::Value obj_value(Json::objectValue); // {}

## ◆ Value() [2/12]

Json::Value::Value | ( | Int | value | ) |

## ◆ Value() [3/12]

Json::Value::Value | ( | UInt | value | ) |

## ◆ Value() [4/12]

Json::Value::Value | ( | Int64 | value | ) |

## ◆ Value() [5/12]

Json::Value::Value | ( | UInt64 | value | ) |

## ◆ Value() [6/12]

Json::Value::Value | ( | double | value | ) |

## ◆ Value() [7/12]

Json::Value::Value | ( | const char * | value | ) |

Copy til first 0. (NULL causes to seg-fault.)

## ◆ Value() [8/12]

Json::Value::Value | ( | const char * | beginValue,
|  | const char * | endValue
| ) |  |

Copy all, incl zeroes.

## ◆ Value() [9/12]

Json::Value::Value | ( | const StaticString & | value | ) |

Constructs a value from a static string.

Like other value string constructor but do not duplicate the string for internal storage. The given string must remain alive after the call to this constructor.

Note
  This works only for null-terminated strings. (We cannot change the size of this class, so we have nowhere to store the length, which might be computed later for various operations.)

Example of usage:

static StaticString foo("some text");
Json::Value aValue(foo);

## ◆ Value() [10/12]

Json::Value::Value | ( | const std::string & | value | ) |

Copy data() til size(). Embedded zeroes too.

## ◆ Value() [11/12]

Json::Value::Value | ( | bool | value | ) |

## ◆ Value() [12/12]

Json::Value::Value | ( | const Value & | other | ) |

Deep copy.

## ◆ ~Value()

Json::Value::~Value | ( |  | ) |

## Member Function Documentation

## ◆ append()

Value& Json::Value::append | ( | const Value & | value | ) |

Append value to array at the end.

Equivalent to jsonvalue[jsonvalue.size()] = value;

## ◆ asBool()

bool Json::Value::asBool | ( |  | ) | const

## ◆ asCString()

const char* Json::Value::asCString | ( |  | ) | const

Embedded zeroes could cause you trouble!

## ◆ asDouble()

double Json::Value::asDouble | ( |  | ) | const

## ◆ asFloat()

float Json::Value::asFloat | ( |  | ) | const

## ◆ asInt()

Int Json::Value::asInt | ( |  | ) | const

## ◆ asInt64()

Int64 Json::Value::asInt64 | ( |  | ) | const

## ◆ asLargestInt()

LargestInt Json::Value::asLargestInt | ( |  | ) | const

## ◆ asLargestUInt()

LargestUInt Json::Value::asLargestUInt | ( |  | ) | const

## ◆ asString()

std::string Json::Value::asString | ( |  | ) | const

Embedded zeroes are possible.

## ◆ asUInt()

UInt Json::Value::asUInt | ( |  | ) | const

## ◆ asUInt64()

UInt64 Json::Value::asUInt64 | ( |  | ) | const

## ◆ begin() [1/2]

const_iterator Json::Value::begin | ( |  | ) | const

## ◆ begin() [2/2]

iterator Json::Value::begin | ( |  | ) |

## ◆ clear()

void Json::Value::clear | ( |  | ) |

Remove all object members and array elements.

Precondition
  type() is arrayValue, objectValue, or nullValue

Postcondition
  type() is unchanged

## ◆ compare()

int Json::Value::compare | ( | const Value & | other | ) | const

## ◆ demand()

Value const* Json::Value::demand | ( | char const * | key,
|  | char const * | end
| ) |  |

Most general and efficient version of object-mutators.

Note
  As stated elsewhere, behavior is undefined if (end-key) >= 2^30

Returns
  non-zero, but JSON_ASSERT if this is neither object nor nullValue.

## ◆ empty()

bool Json::Value::empty | ( |  | ) | const

Return true if empty array, empty object, or null; otherwise, false.

## ◆ end() [1/2]

const_iterator Json::Value::end | ( |  | ) | const

## ◆ end() [2/2]

iterator Json::Value::end | ( |  | ) |

## ◆ find()

Value const* Json::Value::find | ( | char const * | key,
|  | char const * | end
| ) |  | const

Most general and efficient version of isMember()const, get()const, and operator[]const

Note
  As stated elsewhere, behavior is undefined if (end-key) >= 2^30

## ◆ get() [1/4]

Value Json::Value::get | ( | ArrayIndex | index,
|  | const Value & | defaultValue
| ) |  | const

If the array contains at least index+1 elements, returns the element value, otherwise returns defaultValue.

## ◆ get() [2/4]

Value Json::Value::get | ( | const char * | key,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

## ◆ get() [3/4]

Value Json::Value::get | ( | const char * | key,
|  | const char * | end,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

Parameters

  key | may contain embedded nulls.

## ◆ get() [4/4]

Value Json::Value::get | ( | const std::string & | key,
|  | const Value & | defaultValue
| ) |  | const

Return the member named key if it exist, defaultValue otherwise.

Note
  deep copy

Parameters

  key | may contain embedded nulls.

## ◆ getComment()

std::string Json::Value::getComment | ( | CommentPlacement | placement | ) | const

Include delimiters and embedded newlines.

## ◆ getMemberNames()

Members Json::Value::getMemberNames | ( |  | ) | const

Return a list of the member names.

If null, return an empty list.

Precondition
  type() is objectValue or nullValue

Postcondition
  if type() was nullValue, it remains nullValue

## ◆ getOffsetLimit()

size_t Json::Value::getOffsetLimit | ( |  | ) | const

## ◆ getOffsetStart()

size_t Json::Value::getOffsetStart | ( |  | ) | const

## ◆ getString()

bool Json::Value::getString | ( | char const ** | str,
|  | char const ** | end
| ) |  | const

Get raw char* of string-value.

Returns
  false if !string. (Seg-fault if str or end are NULL.)

## ◆ hasComment()

bool Json::Value::hasComment | ( | CommentPlacement | placement | ) | const

## ◆ initBasic()

void Json::Value::initBasic | ( | ValueType | type,
|  | bool | allocated = `false`
| ) |  |
| private

## ◆ isArray()

bool Json::Value::isArray | ( |  | ) | const

## ◆ isBool()

bool Json::Value::isBool | ( |  | ) | const

## ◆ isConvertibleTo()

bool Json::Value::isConvertibleTo | ( | ValueType | other | ) | const

## ◆ isDouble()

bool Json::Value::isDouble | ( |  | ) | const

## ◆ isInt()

bool Json::Value::isInt | ( |  | ) | const

## ◆ isInt64()

bool Json::Value::isInt64 | ( |  | ) | const

## ◆ isIntegral()

bool Json::Value::isIntegral | ( |  | ) | const

## ◆ isMember() [1/3]

bool Json::Value::isMember | ( | const char * | key | ) | const

Return true if the object has a member named key.

Note
  'key' must be null-terminated.

## ◆ isMember() [2/3]

bool Json::Value::isMember | ( | const std::string & | key | ) | const

Return true if the object has a member named key.

Parameters

  key | may contain embedded nulls.

## ◆ isMember() [3/3]

bool Json::Value::isMember | ( | const char * | key,
|  | const char * | end
| ) |  | const

Same as isMember(std::string const& key)const.

## ◆ isNull()

bool Json::Value::isNull | ( |  | ) | const

## ◆ isNumeric()

bool Json::Value::isNumeric | ( |  | ) | const

## ◆ isObject()

bool Json::Value::isObject | ( |  | ) | const

## ◆ isString()

bool Json::Value::isString | ( |  | ) | const

## ◆ isUInt()

bool Json::Value::isUInt | ( |  | ) | const

## ◆ isUInt64()

bool Json::Value::isUInt64 | ( |  | ) | const

## ◆ isValidIndex()

bool Json::Value::isValidIndex | ( | ArrayIndex | index | ) | const

Return true if index < size().

## ◆ operator!()

bool Json::Value::operator! | ( |  | ) | const

Return isNull()

## ◆ operator!=()

bool Json::Value::operator!= | ( | const Value & | other | ) | const

## ◆ operator<()

bool Json::Value::operator< | ( | const Value & | other | ) | const

Compare payload only, not comments etc.

## ◆ operator<=()

bool Json::Value::operator<= | ( | const Value & | other | ) | const

## ◆ operator=()

Value& Json::Value::operator= | ( | Value | other | ) |

Deep copy, then swap(other).

Note
  Over-write existing comments. To preserve comments, use swapPayload().

## ◆ operator==()

bool Json::Value::operator== | ( | const Value & | other | ) | const

## ◆ operator>()

bool Json::Value::operator> | ( | const Value & | other | ) | const

## ◆ operator>=()

bool Json::Value::operator>= | ( | const Value & | other | ) | const

## ◆ operator[]() [1/9]

Value& Json::Value::operator[] | ( | ArrayIndex | index | ) |

Access an array element (zero based index ). If the array contains less than index element, then null value are inserted in the array so that its size is index+1. (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

## ◆ operator[]() [2/9]

Value& Json::Value::operator[] | ( | int | index | ) |

Access an array element (zero based index ). If the array contains less than index element, then null value are inserted in the array so that its size is index+1. (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

## ◆ operator[]() [3/9]

const Value& Json::Value::operator[] | ( | ArrayIndex | index | ) | const

Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

## ◆ operator[]() [4/9]

const Value& Json::Value::operator[] | ( | int | index | ) | const

Access an array element (zero based index ) (You may need to say 'value[0u]' to get your compiler to distinguish this from the operator[] which takes a string.)

## ◆ operator[]() [5/9]

Value& Json::Value::operator[] | ( | const char * | key | ) |

Access an object value by name, create a null member if it does not exist.

Note
  Because of our implementation, keys are limited to 2^30 -1 chars. Exceeding that will cause an exception.

## ◆ operator[]() [6/9]

const Value& Json::Value::operator[] | ( | const char * | key | ) | const

Access an object value by name, returns null if there is no member with that name.

## ◆ operator[]() [7/9]

Value& Json::Value::operator[] | ( | const std::string & | key | ) |

Access an object value by name, create a null member if it does not exist.

Parameters

  key | may contain embedded nulls.

## ◆ operator[]() [8/9]

const Value& Json::Value::operator[] | ( | const std::string & | key | ) | const

Access an object value by name, returns null if there is no member with that name.

Parameters

  key | may contain embedded nulls.

## ◆ operator[]() [9/9]

Value& Json::Value::operator[] | ( | const StaticString & | key | ) |

Access an object value by name, create a null member if it does not exist.

If the object has no entry for that name, then the member name used to store the new entry is not duplicated. Example of use:

Json::Value object;
static const StaticString code("code");
object[code] = 1234;

## ◆ removeIndex()

bool Json::Value::removeIndex | ( | ArrayIndex | i,
|  | Value * | removed
| ) |  |

Remove the indexed array element.

O(n) expensive operations. Update 'removed' iff removed.

Returns
  true iff removed (no exceptions)

## ◆ removeMember() [1/5]

Value Json::Value::removeMember | ( | const char * | key | ) |

Remove and return the named member.

Do nothing if it did not exist.

Returns
  the removed Value, or null.

Precondition
  type() is objectValue or nullValue

Postcondition
  type() is unchanged

Deprecated:

## ◆ removeMember() [2/5]

Value Json::Value::removeMember | ( | const std::string & | key | ) |

Same as removeMember(const char*)

Parameters

  key | may contain embedded nulls.

Deprecated:

## ◆ removeMember() [3/5]

bool Json::Value::removeMember | ( | const char * | key,
|  | Value * | removed
| ) |  |

Same as removeMember(const char* key, const char* end, Value* removed), but 'key' is null-terminated.

## ◆ removeMember() [4/5]

bool Json::Value::removeMember | ( | std::string const & | key,
|  | Value * | removed
| ) |  |

Remove the named map member.

Update 'removed' iff removed.

Parameters

  key | may contain embedded nulls.

Returns
  true iff removed (no exceptions)

## ◆ removeMember() [5/5]

bool Json::Value::removeMember | ( | const char * | key,
|  | const char * | end,
|  | Value * | removed
| ) |  |

Same as removeMember(std::string const& key, Value* removed)

## ◆ resize()

void Json::Value::resize | ( | ArrayIndex | size | ) |

Resize the array to size elements. New elements are initialized to null. May only be called on nullValue or arrayValue.

Precondition
  type() is arrayValue or nullValue

Postcondition
  type() is arrayValue

## ◆ resolveReference() [1/2]

Value& Json::Value::resolveReference | ( | const char * | key | ) |
| private

## ◆ resolveReference() [2/2]

Value& Json::Value::resolveReference | ( | const char * | key,
|  | const char * | end
| ) |  |
| private

## ◆ setComment() [1/3]

void Json::Value::setComment | ( | const char * | comment,
|  | CommentPlacement | placement
| ) |  |

Deprecated:
  Always pass len.

## ◆ setComment() [2/3]

void Json::Value::setComment | ( | const char * | comment,
|  | size_t | len,
|  | CommentPlacement | placement
| ) |  |

Comments must be //... or /* ... */.

## ◆ setComment() [3/3]

void Json::Value::setComment | ( | const std::string & | comment,
|  | CommentPlacement | placement
| ) |  |

Comments must be //... or /* ... */.

## ◆ setOffsetLimit()

void Json::Value::setOffsetLimit | ( | size_t | limit | ) |

## ◆ setOffsetStart()

void Json::Value::setOffsetStart | ( | size_t | start | ) |

## ◆ size()

ArrayIndex Json::Value::size | ( |  | ) | const

Number of values in array or object.

## ◆ swap()

void Json::Value::swap | ( | Value & | other | ) |

Swap everything.

## ◆ swapPayload()

void Json::Value::swapPayload | ( | Value & | other | ) |

Swap values but leave comments and source offsets in place.

## ◆ toStyledString()

std::string Json::Value::toStyledString | ( |  | ) | const

## ◆ type()

ValueType Json::Value::type | ( |  | ) | const

## Friends And Related Function Documentation

## ◆ ValueIteratorBase

friend class ValueIteratorBase
| friend

## Member Data Documentation

## ◆ allocated_

unsigned int Json::Value::allocated_
| private

## ◆ comments_

CommentInfo* Json::Value::comments_
| private

## ◆ limit_

size_t Json::Value::limit_
| private

## ◆ maxInt

const Int Json::Value::maxInt
| static

Maximum signed int value that can be stored in a Json::Value.

## ◆ maxInt64

const Int64 Json::Value::maxInt64
| static

Maximum signed 64 bits int value that can be stored in a Json::Value.

## ◆ maxLargestInt

const LargestInt Json::Value::maxLargestInt
| static

Maximum signed integer value that can be stored in a Json::Value.

## ◆ maxLargestUInt

const LargestUInt Json::Value::maxLargestUInt
| static

Maximum unsigned integer value that can be stored in a Json::Value.

## ◆ maxUInt

const UInt Json::Value::maxUInt
| static

Maximum unsigned int value that can be stored in a Json::Value.

## ◆ maxUInt64

const UInt64 Json::Value::maxUInt64
| static

Maximum unsigned 64 bits int value that can be stored in a Json::Value.

## ◆ minInt

const Int Json::Value::minInt
| static

Minimum signed int value that can be stored in a Json::Value.

## ◆ minInt64

const Int64 Json::Value::minInt64
| static

Minimum signed 64 bits int value that can be stored in a Json::Value.

## ◆ minLargestInt

const LargestInt Json::Value::minLargestInt
| static

Minimum signed integer value that can be stored in a Json::Value.

## ◆ null

const Value& Json::Value::null
| static

We regret this reference to a global instance; prefer the simpler Value().

## ◆ nullRef

const Value& Json::Value::nullRef
| static

just a kludge for binary-compatibility; same as null

## ◆ start_

size_t Json::Value::start_
| private

## ◆ type_

ValueType Json::Value::type_
| private

## ◆ value_

union Json::Value::ValueHolder Json::Value::value_
| private

The documentation for this class was generated from the following file:

- src/visualization/ParaViewCatalystIossAdapter/parser/jsoncpp-master/dist/json/json.h